C*PROPGAT
C+
      SUBROUTINE PROPGAT(AEIOWM,DT)
      DOUBLE PRECISION AEIOWM(6)
      DOUBLE PRECISION DT
C
C Integrate an orbit described by AEIOWM through a time interval
C of DT seconds. Orbital precession due to the "J2" term
C of the earth is included.
C-----------------------------------------------------------------------
C.    IMPLICIT NONE
      DOUBLE PRECISION PI,TWOPI
      PARAMETER  (PI=3.141592653589793 D0)
      PARAMETER  (TWOPI=2D0*PI)
      DOUBLE PRECISION RE,GM,HJ2
      DOUBLE PRECISION EN,SIN2I,ESQ,ASQ,DODT,DWDT,DMDT
      COMMON /EARTH/ RE,GM,HJ2
C
C     -- mean angular velocity
	
      EN = SQRT(GM/AEIOWM(1)**3)
      SIN2I = SIN(AEIOWM(3))**2
      ESQ = 1. - AEIOWM(2)**2
c      write(77,*) 'en=',en,'sin2i=',sin2i,'esq=',esq
      ASQ  = (AEIOWM(1)/RE)**2
      DMDT = EN*(1. + (0.75*HJ2*(2.-3.*SIN2I))/(ASQ*ESQ**1.5))
      DWDT = 3.*EN*HJ2*(4.-5.*SIN2I)/(4.*ASQ*ESQ*ESQ)
      DODT = -1.5*HJ2*COS(AEIOWM(3))*EN/(ASQ*ESQ*ESQ)
C     -- new ascending node
      AEIOWM(4) = AEIOWM(4) + DODT*DT
C     -- new arg. of periapsis
      AEIOWM(5) = AEIOWM(5) + DWDT*DT
C     -- new mean anomaly
      AEIOWM(6) = MOD((AEIOWM(6)+DMDT*DT),TWOPI)
C
      END
