
C*CMODEL -- compute model VISibility at given (u,v) point
C+
      SUBROUTINE CMODEL(UU,VV,VISR,VISI)
      REAL UU, VV
      REAL VISR, VISI
C
C Calculate model VISibility at point (uu,vv).
C
C  7-Dec-1984: correct bug for small QQ in model type 3 [TJP].
C              Further study of numerical accuracy would be useful.
C-----------------------------------------------------------------------
      INTEGER   MAXMOD
      REAL      PI
      PARAMETER (MAXMOD=2000)
      PARAMETER (PI=3.14159265359)
      INTEGER NCOMP
      REAL    FLUX(MAXMOD),X(MAXMOD),Y(MAXMOD),AA(MAXMOD),R(MAXMOD),
     1        PHI(MAXMOD)
      INTEGER ITYPE(MAXMOD)
      COMMON /MODEL/ NCOMP,FLUX,X,Y,AA,R,PHI,ITYPE
C
      INTEGER J
      REAL COMPHA, COMVIS, SPHI, CPHI, Q, QQ, XX
      REAL BESJ0, BESJ1
C
      VISI = 0.0
      VISR = 0.0
      IF (NCOMP.LT.1) GOTO 40
      DO 30 J=1,NCOMP
          COMPHA = 2.0*PI*(UU*X(J)+VV*Y(J))
C
C -- Delta function --
C
          IF (AA(J).EQ.0.0) THEN
              COMVIS = 1.0
          ELSE
              SPHI = SIN(PHI(J))
              CPHI = COS(PHI(J))
              Q = (VV*CPHI + UU*SPHI)**2 + (R(J)*(UU*CPHI-VV*SPHI))**2
              QQ = PI*AA(J)*SQRT(Q)
C
C -- Gaussian --
C
              IF (ITYPE(J).LE.1) THEN
                  COMVIS = EXP(-3.559707*Q*AA(J)**2)
C
C -- Uniform disk --
C
              ELSE IF (ITYPE(J).EQ.2) THEN
                  COMVIS = 2.0*BESJ1(QQ)/QQ
C
C -- Optically thin sphere --
C
              ELSE IF (ITYPE(J).EQ.3) THEN
                  IF (ABS(QQ).LT.1E-5) THEN
                      COMVIS = 1.0
                  ELSE
                      COMVIS = 3.0*(SIN(QQ)-QQ*COS(QQ))/(QQ*QQ*QQ)
C                     [For small QQ, COMVIS = 1.0 + o(QQ**2)]
                  END IF
C
C -- Ring --
C
              ELSE IF (ITYPE(J).EQ.4) THEN
                  COMVIS = BESJ0(QQ)
C
C -- Line --
C
              ELSE IF (ITYPE(J).EQ.5) THEN
                  XX = AA(J)*PI*(UU*SPHI+VV*CPHI)
                  IF (ABS(XX).LT.1E-5) THEN
                      COMVIS = 1.0
                  ELSE
                      COMVIS = SIN(XX)/XX
                  END IF
              ELSE
                  CALL ERROR('Bugcheck')
              END IF
          END IF
          COMVIS = COMVIS*FLUX(J)
          VISI = VISI+COMVIS*SIN(COMPHA)
          VISR = VISR+COMVIS*COS(COMPHA)
   30 CONTINUE
C
   40 RETURN
      END
