
	subroutine gapprox(bandname,x,gain)

! given bandname and x returns approximate VSOP antenna gain
! approximation from Table 1 on page 42 of SES-TD-94-006
!
! where:
!
! bandname = single uppercase character that determines the band
!        x = angle in radians from the antenna pointing direction
!
! DWM 31-Aug-94

	 integer ifreq
	 real x,gain,xdeg
	 character*1 bandname

	 pi = 3.141592654
	 rd = 180.0/pi
	 dr = pi/180.0

! set up ifreq

	if(bandname.eq.'L') ifreq = 1
	if(bandname.eq.'C') ifreq = 2
	if(bandname.eq.'K') ifreq = 3
	
	 xdeg = abs(rd*x)

	if(xdeg.le.50.0) then
	 if(ifreq.eq.1) gain =10**((15.0 - 0.5*xdeg)/10.0)
	 if(ifreq.eq.2) gain =10**((10.0 - 0.4*xdeg)/10.0)
	 if(ifreq.eq.3) gain =10**(3.0/10.0)
	else
	 gain = 10**(-10.0/10.0)
	end if

	return
	end
