
	subroutine PLAN(jd,ip,lamda,beta,d)

C given Julian date and planet number (1=mercury,etc) returns ecliptic
C longitude (lamda) and latitude (beta) of planet at epoch
C PDS pg. 87-112

	integer ip,k	
	double precision tp1(9),lae1(9),lop1(9),e1(9),a1(9),lan1(9)
	double precision i1(9),pi
	double precision tp,lae,lop,e,a,lan,jd,jd1980,numd,i
	double precision np,mp,lp,nup,rp,ne,me,le,nue,re,phi
	double precision x,y,ldash,a2,lamda,beta,rdash
	double precision ap,p,q,v,b,t,dl,d


c planet orbital elements for 1980.0
	
	data (tp1(k),k=1,9)/0.24085d0,0.61521d0,1.00004d0,
     *                       1.88089d0,11.86224d0,29.45771d0,
     *                       84.01247d0,164.79558d0,250.9d0/

	data (lae1(k),k=1,9)/231.2973d0,355.73352,98.833540,126.30783,
     *   146.966365d0,165.322242d0,228.070855d0,260.3578998d0,209.439d0/

	data (lop1(k),k=1,9)/77.1442128d0,131.2895792d0,102.596403d0,
     *   335.6908166,
     *   14.0095493d0,92.6653974d0,172.7363288d0,47.8672148d0,222.972/

        data (e1(k),k=1,9)/0.2056306d0,0.0067826d0,0.016718d0,
     *    0.0933865d0
     *   ,0.0484658d0,0.0556155d0,0.0463232d0,0.0090021d0,0.25387d0/

        data (a1(k),k=1,9)/0.3870986d0,0.7233316d0,1.0d0,
     *   1.5236883d0,5.202561d0,9.554747d0,19.21814d0,30.10957d0,
     *   39.78459d0/

	data (i1(k),k=1,9)/7.0043579d0,3.394435d0,0.0d0,1.8498011d0
     *  ,1.3041819d0,2.4893741d0,0.7729895d0,1.7716017d0,17.137d0/

	data (lan1(k),k=1,9)/48.0941733d0,76.4997524d0,0.0d0,
     *  49.4032001d0,100.2520175d0,113.4888341d0,
     *  73.8768642d0,131.5606494d0,109.941d0/


	pi=3.141592654

        tp=tp1(ip)
        lae=lae1(ip) 
        lop=lop1(ip)
	  e=e1(ip)
	  a=a1(ip)
	  i=i1(ip)
	lan=lan1(ip)


!       call JUD(1,1,1980,0,0,0.0,jd1980)
        call JUD(1,1,1980,0,0,0.0d0,jd1980)
	
        numd=jd-jd1980+1.0d0

     	np=(360.0d0/365.2422d0)*numd/tp

	np=dmod(np,360.0d0)

     	mp=np+lae-lop
	mp=dmod(mp,360.0d0)


C	 mp=mp*(pi/180.0d0)
C     	 lp=np+(360.0/pi)*e*dsin(mp)+lae
C	 lp=dmod(lp,360.0d0)
C	 nup=lp-lop
        
	 call KEP(mp,e,1.0d-12,nup)
	 lp=nup+lop


C	perturbations to Jupiter's and Saturn's orbit
C	PDS pg. 109 to 110

	if(ip.eq.5.or.ip.eq.6) then


	 t=(jd-2415020.0d0)/36525.0d0
	 ap=0.1d0+t/5.0d0
	 p=(pi/180.0d0)*(237.47555d0+3034.9061d0*t)
	 q=(pi/180.0d0)*(265.91650d0+1222.1139d0*t)
	 v=5.0d0*q-2.0d0*p
	 b=q-p

	 if(ip.eq.5) then
	  dl=((0.3314d0-0.0103d0*ap)*dsin(v))-(0.0644d0*ap*dcos(v))
	 else
	  dl=((0.1609d0*ap-0.0105d0)*dcos(V))+((0.0182d0*ap-0.08142d0)*dsin(v))
	  dl=dl-(0.1488d0*dsin(b))-(0.0408d0*dsin(2.0d0*b))
	  dl=dl+(0.0856d0*dsin(b)*dcos(q))+(0.0813d0*dcos(b)*dsin(q))
	 end if

C	write(*,*) 't,a,p,q,v,dl '
C	write(*,*) t,ap,p*(180.0d0/pi),q*(180.0d0/pi),v*(180.0d0/pi),dl
	
	lp=lp+dl

	end if
	


C	write(*,*)'numd, np, mp, lp, nup '
C	write(*,*) numd,np,mp,lp,nup
	
     	nup=nup*(pi/180.0d0)

     	rp=a*(1-e*e)/(1+e*dcos(nup))

     	ne=(360.0d0/365.2422d0)*numd/tp1(3)
	ne=dmod(ne,360.0d0)

     	me=ne+lae1(3)-lop1(3)
	me=dmod(me,360.0d0)



C     	me=me*(pi/180.0d0)
C     	le=ne+(360.0/pi)*e1(3)*dsin(me)+lae1(3)
C	le=dmod(le,360.0d0)
C    	nue=le-lop1(3)

	call KEP(me,e1(3),1.0d-12,nue)
	le=nue+lop1(3)
	
C	write(*,*) 'ne,me,le,nue '
C	write(*,*) ne,me,le,nue
	
     	nue=nue*(pi/180.0d0)

     	re=(1-e1(3)*e1(3))/(1+e1(3)*dcos(nue))

C	write(*,*) 'rp,re ',rp,re

     	lan=lan*pi/180.0d0
	
     	lp=lp*pi/180.0d0
	
     	le=le*pi/180.0d0

     	i=i*pi/180.0

     	phi=dasin(dsin(lp-lan)*dsin(i))
     	y=dsin(lp-lan)*dcos(i)
     	x=dcos(lp-lan)

     	ldash=datan2(y,x)+lan

    	 rdash=rp*dcos(phi)

C	write(*,*) 'phi,y,x,ldash,rdash'
C	write(*,*) phi,y,x,ldash,rdash

	if(ip.le.3) then

     	y=rdash*dsin(le-ldash)
     	x=re-rdash*cos(le-ldash)
	
     	a2=datan2(y,x)

     	lamda=(pi+le+a2)

	else
	
	y=re*dsin(ldash-le)
	x=rdash-re*dcos(ldash-le)

	lamda=datan2(y,x)+ldash

	end if		
  

     	y=rdash*dtan(phi)*dsin(lamda-ldash)
     	x=re*dsin(ldash-le)
	
        beta=datan(y/x)

        beta=(180.0/pi)*beta

        lamda=(180.0/pi)*lamda
	lamda=dmod(lamda,360.0d0)
	if(lamda.le.0.0d0) lamda=lamda+360.0d0

C	write(*,*) 'lamda, beta ',lamda,beta

	d=(rp*dcos(beta)*dcos(ldash-le)-re)**2
	d=d+(rp*dcos(beta)*dsin(ldash-le))**2
	d=d+(rp*dsin(beta))**2
	d=1.49597892d11*sqrt(d)


	return
	end
