C*GTMODL -- read one model component from file
C+
      SUBROUTINE GTMODL(INMOD,ITYPE,P1,P2,P3,P4,P5,P6,*,OUTMOD)
      INTEGER INMOD, ITYPE, OUTMOD
      REAL    P1, P2, P3, P4, P5, P6
C
C T.J.Pearson   1979 FEB 18
C Modified for VAX version  1979 JULY 5
C Modified to allow comments 1981 February 9
C Modified to copy input comments to an output file 1982 September 22
C
C Read one model component (card) from unit 'INMOD'.
C Each card carries up to 7 numbers:
C 6 floating-point parameters P1-P6, and an optional integer ITYPE.
C Copy comments following a '!' character to unit 'OUTMOD'
C 	Ignore zero-flux components (or blank lines)
C-----------------------------------------------------------------------
      REAL PARS(7)
      DOUBLE PRECISION KCTOR
      CHARACTER*80 CARD
      CHARACTER BLANK, EXCL
      INTEGER I, J, L
      CHARACTER*64 FNAME
      DATA BLANK/' '/
      DATA EXCL/'!'/
C
   5  READ(INMOD, '(A)', END=40) CARD
      L = 80
   10 IF (CARD(L:L).EQ.BLANK) THEN
            L = L-1
            IF (L.LT.1) GOTO 5
        GOTO 10
      END IF
C
      I = 1
      DO 30 J=1,7
          CALL KSKIPB(CARD,I)
          PARS(J) = KCTOR(CARD,I)
   30 CONTINUE
      IF (I.GT.L) GOTO 50
      IF (CARD(I:I).EQ.BLANK) GOTO 50
      IF (CARD(I:I).EQ.EXCL) THEN
            IF (OUTMOD.GT.0) WRITE (OUTMOD,'(A)') CARD(I:L)
            GOTO 50
      END IF
      INQUIRE(UNIT=INMOD,NAME=FNAME)
      CALL ERROR('Invalid model format: file '//FNAME)
   50 CONTINUE
      P1 = PARS(1)
      IF (P1.EQ.0.0) GOTO 5
      P2 = PARS(2)
      P3 = PARS(3)
      P4 = PARS(4)
      P5 = PARS(5)
      P6 = PARS(6)
      ITYPE = PARS(7)
      RETURN
C
   40 RETURN 1
      END
